/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __draw_ViewNull_h__
#define __draw_ViewNull_h__

namespace fe
{

/**************************************************************************//**
	@brief ViewI with no effect

	@ingroup draw
*//***************************************************************************/
class FE_DL_EXPORT ViewNull:
	virtual public ViewI
{
	public:

virtual	void			setWindow(sp<WindowI> spWindowI)					{}
virtual	sp<WindowI>		window(void) const		{ return sp<WindowI>(NULL); }

virtual	void			setViewMode(sp<ViewMode> spViewMode)				{}
virtual	sp<ViewMode>	viewMode(void) const	{ return sp<ViewMode>(NULL); }

virtual	void					setProjection(
									ViewMode::Projection a_projection)		{}
virtual	void					use(ViewMode::Projection a_projection)		{}
virtual	ViewMode::Projection	projection(void) const
								{	return ViewMode::e_none; }

virtual	SpatialVector	unproject(Real winx,Real winy,Real winz,
								ViewMode::Projection a_projection=
								ViewMode::e_current) const
						{	return SpatialVector(0.0,0.0,0.0); }

virtual	SpatialVector	project(const SpatialVector& point,
								ViewMode::Projection a_projection=
								ViewMode::e_current) const
						{	return SpatialVector(0.0,0.0,0.0); }

virtual	Real			pixelSize(const SpatialVector& center,
								Real radius) const		{ return 0.0; }

virtual	Real			worldSize(const SpatialVector& center,
								Real pixels) const		{ return 0.0; }

virtual	void			screenAlignment(SpatialTransform &a_rotation)		{}

virtual	void			screenInfo(Real &a_screenScale,
							SpatialVector &a_screenLocation,
							const SpatialTransform &a_rotation,
							const SpatialVector &a_location)				{}

};

} // namespace

#endif /* __draw_ViewNull_h__ */
