#! /usr/bin/python

import sys

if len(sys.argv) < 2:
	print "Usage: " + sys.argv[0] + " filename [start] [end]"
	exit()

filename = sys.argv[1]

if len(sys.argv) > 2:
	start = int(sys.argv[2])
else:
	start = 1

if len(sys.argv) > 3:
	end = int(sys.argv[3])
else:
	end = start

import pyfe

fe = pyfe.Context()
fe.manage("fexOperatorDL")
fe.manage("fexOpLabDL")

surfaceViewerOp = fe.create("SurfaceViewerOp")

surfaces = {}

while True:
	for frame in range(start, end + 1):
		fe.setFrame(frame)

		if not frame in surfaces:
			surfaces[frame] = fe.load(filename.replace("$F", str(frame)))

		surfaceViewerOp(surfaces[frame])
